 #include <DynamixelSoftSerial.h>
 #include <SoftwareSerial.h>
 int pumpPin = 10;                   // Set the pin to digital I/O 13
 int posServo1 = 203;                // 
 int posServo2 = 400;                //
 int posServo3 = 950;                //
 
 
 void setup() {
   pinMode(pumpPin, OUTPUT);        // Set pin as OUTPUT
   Serial.begin(19200);
   Dynamixel.begin(19200,2,3,4);  // Inicialize the servo at 1Mbps and Pin Control 2
 }


 void loop() {

   if (Serial.available()){                     // If data is available to read,
     int /*oder char?*/ val = Serial.read();    // read it and store it in val
     switch (val) {                             // übertragenen Wert genauer untersuchen

//MAGNETVENTIL
      case 'A': {                               // Wenn A = AUF enthalten ist
        digitalWrite(pumpPin, HIGH);            // turn the Pumpe ON
      break;
      }
      case 'Z': {                               // Wenn Z = ZU enthalten ist
        digitalWrite(pumpPin, LOW);             // turn the Pump OFF
      break;
      }

//SERVOS
      case 'S': {                               // Wenn S = STARTPOSITION enthalten ist
        Dynamixel.moveSpeed(1,203, 100);        // Move Servo 1 to position 510
        Dynamixel.moveSpeed(2,400, 100);        // Move Servo 2 to position 400
        Dynamixel.moveSpeed(3,950, 100);        // Move Servo 3 to position 600
        Serial.print("Servo1(K): 90\nServo2(L): 147\nServo3(M): 308\n");
      break;
      }
      case 'K': {                               // Wenn K = Servo1 enthalten ist
        int winkelServo1=Serial.parseInt();
        posServo1=(winkelServo1-30)*3.41;  // lies die folgende Zahl ein
                                                // zieh 30° ab (invalid angle-Bereich d.Servos)
                                                // multipliziere das Ergebnis mit 3.41, denn:
                                                // Umrechnung Winkel zu Servosteps: 1° = 3.41 steps
        Serial.print("Servo1(K): ");
        Serial.println(winkelServo1);
        Dynamixel.moveSpeed(1,posServo1, 100);  // Move Servo 1 to position 'posServo1'
      break;                                    // höre hier auf.
      }
      case 'L': {                               // Wenn L = Servo2 enthalten ist
        int winkelServo2=Serial.parseInt();
        posServo2=(winkelServo2-30)*3.41;  // lies die folgende Zahl ein
                                                // zieh 30° ab (invalid angle-Bereich d.Servos)
                                                // multipliziere das Ergebnis mit 3.41, denn:
                                                // Umrechnung Winkel zu Servosteps: 1° = 3.41 steps
        Serial.print("Servo2(L): ");
        Serial.println(winkelServo2);
        Dynamixel.moveSpeed(2,posServo2, 100);  // Move Servo 2 to position 'posServo2'
      break;                                    // höre hier auf.
      }
      case 'M': {                               // wenn M = Servo3 enthalten ist
        int winkelServo3=Serial.parseInt();
        posServo3=(winkelServo3-30)*3.41;  // lies die folgende Zahl ein
                                                // zieh 30° ab (invalid angle-Bereich d.Servos)
                                                // multipliziere das Ergebnis mit 3.41, denn:
                                                // Umrechnung Winkel zu Servosteps: 1° = 3.41 steps
        Serial.print("Servo3(M): ");
        Serial.println(winkelServo3);
        Dynamixel.moveSpeed(3,posServo3, 100);  // Move Servo 3 to position 'posServo1'
      break;                                    // höre hier auf.
      }
     }
   }
 }

 
 /*MAGNETVENTIL
   if (val == '1'){                 // If 1 = AUF was received
     digitalWrite(pumpPin, HIGH);   // turn the Pumpe ON
   } 
   if (val == '2'){                 // If 2 = ZU was received
     digitalWrite(pumpPin, LOW);    // turn the Pump OFF
   }

 //SERVOS   
   if (val == '3'){
      Dynamixel.moveSpeed(1,203, 100);  // Move Servo 1 to position 510
      Dynamixel.moveSpeed(2,600, 100);  // Move Servo 2 to position 400
      Dynamixel.moveSpeed(3,680, 100);  // Move Servo 3 to position 600
     
   }
   if (val == '4'){
      Dynamixel.moveSpeed(1,203, 100);  // Move Servo 1 to position 510
      Dynamixel.moveSpeed(2,400, 100);  // Move Servo 2 to position 400
      Dynamixel.moveSpeed(3,950, 100);  // Move Servo 3 to position 600
   }
   if (val == '5'){
    Dynamixel.moveSpeed(1,posServo1+1,20);
    posServo1 = posServo1+1;
   }
   if (val == '6'){
    Dynamixel.moveSpeed(1,posServo1-1,20);
    posServo1 = posServo1-1;
   } 
   if (val == '9'){
    Dynamixel.moveSpeed(2,posServo2+1,20);
    posServo2 = posServo2+1;
    Dynamixel.moveSpeed(3,posServo3-1,20);
    posServo3 = posServo3-1;
   }
   if (val == '7'){
    Dynamixel.moveSpeed(3,posServo3-1,20);
    posServo3 = posServo3-1;
    
   }
   if (val == '8'){
    Dynamixel.moveSpeed(3,posServo3+1,20);
    posServo3 = posServo3+1;
   }
      
} */

